<template>
    <v-dialog
      v-model="dialog"
      width="500"
    >
      <v-card v-if="!displayConfirm">
        <v-list-item>
          <v-list-item-avatar :color="event.data.user.color"></v-list-item-avatar>
          <v-list-item-content>
            <v-list-item-title class="headline">{{event.name}}</v-list-item-title>
            <v-list-item-subtitle><v-icon>mdi-account</v-icon>{{event.data.user.displayName}}</v-list-item-subtitle>
          </v-list-item-content>
        </v-list-item>
        <!-- <v-card-title class="headline">{{event.name}}</v-card-title> -->
        <v-card-text>
          {{event.data.description}}
        </v-card-text>
        <v-divider class="mx-4"></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue darken-1" :ripple="false" text @click="dialog = close">Retour</v-btn>
          <v-btn color="blue darken-1" v-if="hasActionRights" :ripple="false" text @click="displayEditEvent()"><v-icon>mdi-border-color</v-icon>Modifier</v-btn>
          <v-btn color="blue darken-1" v-if="hasActionRights" :ripple="false" text @click="displayConfirm = true"><v-icon>mdi-delete</v-icon>Supprimer</v-btn>
        </v-card-actions>
      </v-card>
      <v-card v-else>
          <v-card-title>Confirmation de la suppression</v-card-title>
          <v-card-text>Êtes-vous sur de vouloir supprimer l'évènement <strong>{{event.name}}</strong>?</v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue darken-1" :ripple="false" text @click="displayConfirm = false">Retour</v-btn>
          <v-btn color="blue darken-1" :ripple="false" text @click="deleteEvent(event._id)"><v-icon>mdi-delete</v-icon>Valider</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
</template>

<script lang="ts">
import { Component, Vue, Prop, Watch } from 'vue-property-decorator';
import CalendarEvent from '../../transport/CalendarEvent';
import EventService from '../../services/eventService';
import methods from '../../utils/methods';
import { mapState } from "vuex";

@Component({
  computed:{
    ...mapState([
      'user'
    ])},
})
export default class CalendarPopOver extends Vue{
  private dialog = true;
  @Prop({ default: null }) private event: CalendarEvent;
  private _eventService: EventService = null;
  private displayConfirm: boolean = false;

  mounted(){
    this._eventService = new EventService;
  }
  
  @Watch('event', {immediate: true, deep: true})
  onEventChange(){
    this.dialog = true;
  }

  @Watch('dialog')
  onDialogClose(){
    this.dialog = false;
    this.$emit("isClose")
  }

  get hasActionRights(): boolean{
    if(!this.$store.state.user) return false;
    return this.$store.state.user.isAdmin || 
      (this.$store.state.user.isValid && 
      this.event.data.user._id === this.$store.state.user._id);
  }
  private displayEditEvent(){
    this.$emit("displayEditEvent")
  }
  private deleteEvent(){
    if(!methods.isNullOrWhiteSpace(this.event.data._id)){
      this._eventService.deleteEvent(this.event.data._id).then(() => {
        this.displayConfirm = false;
        this.$emit('reloadEvents');
        this.onDialogClose();
      });
    }
  }
}
</script>

<style>
/* Fix: Le title de l'évènement était coupé si il était trop long */
div.v-list-item__title.headline
{
  text-overflow: initial;
  white-space: normal;
}
</style>